// JHtml - (c)1998 Romain GUY
// Cette classe transforme les caractres accentus d'un fichier HTML en unicode ou le contraire
// Retourne: - 0 si russi
//           - 1 si erreur de commande
//           - 2 si erreur de lecture
//           - 3 si erreur d'criture

import java.io.*;

public class JHtml
{
  static final String accent[] = { "", "", "", "", "", "", "", "", "", "", "", "", "", "" };
  static final String unicode[] = { "eacute", "egrave", "ecirc", "euml", "agrave", "acirc", "auml", "icirc", "iuml", "ugrave", "uuml", "ucirc", "ocirc", "ouml" };

  static public void command()
  {
    System.out.println("JHtml - (c)1998 Romain GUY\nCette classe permet de transformer les accents des HTML en unicode\n\njava JHtml <type> <fichier1> ... <fichierN>\n<type>: 1 (accent vers unicode) ou 2 (unicode vers accent)");
    System.exit(1);
  }

  static public void readError(String file)
  {
    System.out.println("Erreur en lisant " + file);
    System.exit(2);
  }

  static public void writeError(String file)
  {
    System.out.println("Erreur en enregistrant " + file);
    System.exit(3);
  }

  public static void main(String args[])
  {
    String compare, replace;
    String html = new String("");
    System.out.println();
    if ((args.length < 2) || ((!args[0].equals("1")) && (!args[0].equals("2")))) command();
    for (int j = 1; j < args.length; j++)
    {
      if ((args[j].indexOf(".htm") == -1) && (args[j].indexOf(".html") == -1)) continue;
      File source = new File(args[j]);
      if (!source.exists()) readError(args[j]);
      try
      {
        RandomAccessFile raf = new RandomAccessFile(args[j], "r");
        byte b[] = new byte[new Long(raf.length()).intValue()];
        raf.read(b);
        html = new String(b);
        raf.close();
      }
      catch (IOException e)
      {
        readError(args[j]);
      }

      for (int i = 0; i < accent.length; i++)
      {
        int search = 0;
        while (search != -1)
        {
          if (args[0].equals("1"))
          {
  	    compare = accent[i];
  	    replace = "&" + unicode[i] + ";";
  	  }
	  else
	  {
	    compare = "&" + unicode[i] + ";";
	    replace = accent[i];
	  }
          search = html.indexOf(compare);
	  if (search != -1) html = html.substring(0, search) + replace + html.substring(search + compare.length());
        }
      }

      try
      {
        source.delete();
        RandomAccessFile raf = new RandomAccessFile(args[j], "rw");
        raf.write(html.getBytes());
        raf.close();
      }
      catch (IOException e)
      {
        writeError(args[j]);
      }
      System.out.println("Modifications sur " + args[j] + " finies.");
    }
    System.exit(0);
  }
}
